import pygame
import pygame.locals as l
import random
import math
def out(text):
    f = open("logfile.txt","w")
    f.write(text)
    f.close()
screen = pygame.display.set_mode([640,480],l.HWSURFACE|l.DOUBLEBUF)
pygame.display.set_caption("Embers")
pygame.display.set_icon(pygame.image.load("data/icon.tga"))

#import psyco
#psyco.full()

import sys
out("17hello!")

class ob(object):
    def __get__(self,attr):
        return object.__getattribute__(self,attr)
        
out("ob")
        
circle = pygame.Surface([screen.get_width(),screen.get_width()]).convert()
pygame.draw.circle(circle,[255,0,255],[screen.get_width()/2,screen.get_width()/2],screen.get_width()/2)
circle.set_colorkey([0,0,0])

out("29circle")

class lightsource(ob):
    def __init__(self,pos,radi):
        self.pos = pos
        self.radi = radi
        self.expand = 0.0
        self.expanddir = 1
    def __getattr__(self,attr):
        if attr=="rect":
            radi = self.getradi()
            dia=radi*2
            return pygame.Rect([int(self.pos[0]-radi),int(self.pos[1]-radi),int(dia),int(dia)])
        return ob.__get__(self,attr)
    def update(self,dt):
        if self.expand <= 3.0 and self.expand >= -3.0:
            self.expand += self.expanddir
        else:
            self.expanddir = -self.expanddir
            if self.expand >3.0:
                self.expand = 2.9
            if self.expand < -3.0:
                self.expand = -2.9
        radi = self.radi + 5
        dia = radi*2
        dirtyrects.append([int(self.pos[0]-radi),int(self.pos[1]-radi),int(dia),int(dia)])
    def getradi(self):
        return int(self.radi + self.expand)
    def blit(self,dest):
        radi = self.getradi()
        if radi>0:
            #self.surf.fill([0,0,0])
            #center = self.surf.get_width()/2,self.surf.get_height()/2
            scaled = pygame.transform.scale(circle,[radi*2,radi*2])
            #pygame.draw.circle(self.surf,[255,0,255],center,radi)
            #pygame.draw.polygon(self.surf,[255,0,255],
            #[[center[0]-radi,center[1]],[center[0]-radi/2,center[1]-radi],[center[0]+radi/2,center[1]-radi],[center[0]+radi,center[1]],
            #[center[0]+radi/2,center[1]+radi],[center[0]-radi/2,center[1]+radi],[center[0]-radi,center[1]]])
            dest.blit(scaled,[self.pos[0]-scaled.get_width()/2,self.pos[1]-scaled.get_height()/2])
    def blitcolors(self,*args):
        pass

out("67lightsource")

firepic = pygame.image.load("data/fire.png")
fires = {"yellow":firepic.subsurface([2,8,46,56]),"orange":firepic.subsurface([60,2,44,60]),"red":firepic.subsurface([111,8,42,54])}

out("72fires")

class firepiece(ob):
    def __init__(self,color,pos,size):
        self.offset = [0,0]
        self.basesurf = fires[color]
        self.surf = self.basesurf.convert()
        self.size = float(size)#Amount of size difference to radius
        self.velocity = [0,0]
        self.r0 = random.random()
        self.r1 = random.random()
        self.acceleration = [random.choice([-self.r0,self.r0]),random.choice([-self.r0,self.r0])]
        self.pos = pos
    def scale(self,radi):
        self.surf = pygame.transform.scale(self.basesurf,[int((radi+3.0)/self.size),int((radi+3.0)/self.size)])
        self.surf.set_colorkey([255,255,255])
    def update(self,dt,newradi):
        self.scale(newradi)
        dif = self.offset[:]
        if dif[0]:
            self.acceleration[0] = -self.r0*abs(dif[0])/dif[0]
        if dif[1]:
            self.acceleration[1] = -self.r1*abs(dif[1])/dif[1]
        self.velocity[0]+=self.acceleration[0]
        self.velocity[1]+=self.acceleration[1]
        max = .3
        if self.velocity[0]>max:
            self.velocity[0]=max
        if self.velocity[0]<-max:
            self.velocity[0]=-max
        if self.velocity[1]>max:
            self.velocity[1]=max
        if self.velocity[1]<-max:
            self.velocity[1]=-max
        self.offset[0]+=self.velocity[0]
        self.offset[1]+=self.velocity[1]
    def blit(self,dest):
        dest.blit(self.surf,[self.pos[0]-self.surf.get_width()/2+self.offset[0],self.pos[1]-self.surf.get_height()/2+self.offset[0]])
    def get_height(self):
        return self.surf.get_height()
    def get_width(self):
        return self.surf.get_width()
        
out("115firepiece")
        
class fire(lightsource):
    def __init__(self,*args):
        lightsource.__init__(self,*args)
        self.redsource = pygame.Surface([10,10]).convert()
        self.colors = []
        self.colors.append(firepiece("yellow",self.pos,2))
        self.colors.append(firepiece("orange",self.pos,2.2))
        self.colors.append(firepiece("red",self.pos,3))
        self.torch = 0
        self.monitor = 1
    def __getattr__(self,attr):
        if attr=="rect":
            return pygame.Rect([int(self.pos[0]-self.colors[0].get_width()/2),int(self.pos[1]-self.colors[0].get_height()/2),self.colors[0].get_width(),self.colors[0].get_height()])
        return lightsource.__getattr__(self,attr)
    def blitcolors(self,dest):
        for fire in self.colors:
            fire.blit(dest)
    def blit(self,dest):
        lightsource.blit(self,dest)
    def update(self,dt):
        self.radi -= .1
        lightsource.update(self,dt)
        for c in self.colors:
            c.update(dt,self.radi)
        wi,hi = self.colors[0].get_width(),self.colors[0].get_height()
        dirtyrects.append([int(self.pos[0]),int(self.pos[1]),int(wi),int(hi)])
        
out("142fire")

treeimage = pygame.image.load("data/trees.png")
treeimage.set_colorkey([255,255,255])
treesurf = treeimage.subsurface([244,186,80,85])
stumpsurf = treeimage.subsurface([396,196,62,54])

out("149trees")

mensimage = pygame.image.load("data/mens.png")
mensimage.set_colorkey([255,255,255])
mansurf = mensimage.subsurface([231,146,54,39])
monsurf = mensimage.subsurface([300,144,68,33])
manchop = mensimage.subsurface([232,201,54,39])
bilesurf = mensimage.subsurface([322,100,19,21])

out("156mens")

class tree(ob):
    def __init__(self,pos):
        self.pos = pos[:]
        self.lastpos = self.pos[:]
        self.state = "tree"
    def blit(self,dest,rec=None):
        if self.state == "tree":
            img = treesurf
        elif self.state == "stump":
            img = stumpsurf
        dest.blit(img,[self.pos[0]-img.get_width()/2,self.pos[1]-img.get_height()/2])
    def update(self,dt):
        #~ if self.lastpos[0]!=self.pos[0] or self.lastpos[1]!=self.pos[1]:
            #~ self.lastpos = self.pos[:]
        dirtyrects.append([int(self.pos[0]-treesurf.get_width()/2),int(self.pos[1]-treesurf.get_height()/2),int(treesurf.get_width()),int(treesurf.get_height())])
    def __getattr__(self,attr):
        if attr=="rect":
            return pygame.Rect([int(self.pos[0]-treesurf.get_width()/2),int(self.pos[1]-treesurf.get_height()/2),treesurf.get_width(),treesurf.get_height()])
        return ob.__get__(self,attr)
    def __hasattr__(self,attr):
        if attr=="rect":
            return True
        return ob.__hasattr__(self,attr)
        
out("182tree")

def circlefromrect(rect):
    """Makes a circle that fits a rect, radius is biggest axis"""
    wi,hi = rect[2],rect[3]
    li = [wi,hi]
    li.sort()
    radi = li[1]/2
    colpos = [rect[0]+radi,rect[1]+radi]
    return colpos,radi
        
class man(ob):
    def __init__(self,pos,dir=0,image=mansurf,carrylimit=None):
        self.pos = pos
        self.dir = dir
        self.lastdir = dir
        self.image = image
        self.rotsurf = pygame.transform.rotate(image,dir)
        self.torch = None
        self.wood = 0
        self.carrylimit = carrylimit
    def __getattr__(self,attr):
        if attr=="rect":
            return pygame.Rect([int(self.pos[0]-self.rotsurf.get_width()/2),int(self.pos[1]-self.rotsurf.get_height()),self.rotsurf.get_width(),self.rotsurf.get_height()])
        return ob.__get__(self,attr)
    def pointforward(self,amount):
        val = -(self.dir+90)*(math.pi/180.)
        while val<0:
            val += 2*math.pi
        x = amount*math.cos(val)
        y = amount*math.sin(val)
        newx = self.pos[0]+x
        newy = self.pos[1]+y
        return newx,newy
    def moveforward(self,amount,collidelist=[]):
        newx,newy = self.pointforward(amount)
        for col in collidelist:
            cpos,cradi = circlefromrect(col.rect)
            #~ dot = pygame.Surface([2,2])
            #~ dot.fill([34,89,3])
            #~ screen.blit(dot,cpos)
            #~ screen.blit(dot,[cpos[0]+cradi,cpos[1]])
            #~ pygame.display.flip()
            #~ for i in range(100):
                #~ pass
            #pos,radi = circlefromrect(self.rect)
            ran = (cradi)**2
            dif = (cpos[0]-newx)**2+(cpos[1]-newy)**2
            if dif<=ran:
                return
        self.pos[0] = newx
        self.pos[1] = newy
    def angleto(self,point):
        p1 = self.pos[:]
        p2 = point[:]
        dx = p1[0]-p2[0]
        dy = p1[1]-p2[1]
        quad = 1
        if dx>0 and dy>0:
            quad = 4
        if dx>0 and dy<=0:
            quad = 1
        if dx<=0 and dy<=0:
            quad = 2
        if dx<=0 and dy>0:
            quad = 3
        ang = math.atan(float(dy)/float(dx))
        ang = -(ang*(180./math.pi)-90)
        if quad==3 or quad==2:
            ang+=180
        while ang>360:
            ang -= 360
        while ang<0:
            ang += 360
        dang = self.dir-ang
        while dang<-180:
            dang += 360
        return dang
    def aimto(self,point,speed=0.2):
        dang = self.angleto(point)
        if dang:
            self.rotate(dang,speed)
    def rotate(self,angle,speed=0.2):
        self.dir+=-int(float(angle)*speed)
    def update(self,dt):
        if self.dir!=self.lastdir:
            self.lastdir = dir
            self.rotsurf = pygame.transform.rotate(self.image,self.dir)
        if self.torch:
            val = -(self.dir+90-50)*(math.pi/180.)
            while val<0:
                val += 2*math.pi
            x = 25*math.cos(val)
            y = 25*math.sin(val)
            self.torch.pos[0],self.torch.pos[1] = [self.pos[0]+x,self.pos[1]+y]
        dirtyrects.append([int(self.pos[0]-self.rotsurf.get_width()/2),int(self.pos[1]-self.rotsurf.get_height()/2),int(self.rotsurf.get_width()),int(self.rotsurf.get_height())])
        
        #self.aimat([screen.get_width()/2,screen.get_height()/2])
    def blit(self,dest):
        dest.blit(self.rotsurf,[self.pos[0]-self.rotsurf.get_width()/2,self.pos[1]-self.rotsurf.get_height()/2])

class biles(man):
    def __init__(self,pos,dir,target,lis=[],image=bilesurf):
        man.__init__(self,pos,dir,image)
        self.lis = lis
        li = lightsource(self.pos,10)
        print li.rect
        self.lis.append(li)
    def update(self,dt):
        self.moveforward(4)
        man.update(self,dt)

class monster(man):
    def __init__(self,pos,dir,target=None,lis=[],bile=[],image=monsurf):
        man.__init__(self,pos,dir,image)
        self.target = target
        self.lis = lis
        self.bile = bile
        self.lastbile = -1
    def update(self,dt):
        man.update(self,dt)
        
        movepoints = 5
        
        #Avoid lights
        px,py = self.pointforward(3)
        #~ dot = pygame.Surface([2,2])
        #~ dot.fill([34,89,3])
        #~ screen.blit(dot,[px,py])
        #screen.blit(dot,[cpos[0]+cradi,cpos[1]])
        pygame.display.flip()
        for li in self.lis:
            lpos,lradi = li.pos,li.getradi()
            #~ dot = pygame.Surface([2,2])
            #~ dot.fill([34,89,3])
            #~ screen.blit(dot,lpos)
            #~ screen.blit(dot,[lpos[0]+lradi,lpos[1]])
            #~ pygame.display.flip()
            ran = ((lradi)*2+10)**2
            dif = (lpos[0]-px)**2+(lpos[1]-py)**2
            if dif<=ran:
                #print "d:",dif,"px,py:",[px,py],"lpos:",lpos,
                dang = self.angleto(li.pos)
                self.rotate(dang,-.5)
                self.moveforward(3)
                return
            
        #track man
        if self.target:
            dang = self.angleto(self.target.pos)
            if abs(dang)<10 and self.lastbile<0:
                self.lastbile = 0
                self.bile.append(biles(self.pos[:],self.dir,self.target,self.lis))
            self.rotate(dang)
            
        #Update bile
        if self.lastbile>=0:
            self.lastbile += dt
            if self.lastbile > 1:
                self.lastbile = -1
                print "done"
            
        #go
        self.moveforward(3)
        
out("258monster")

pygame.font.init()
fo = pygame.font.Font("data/SuperMarioBros.ttf",18)

out("263font")

class goaltext:
    def __init__(self,pos,text,maxsize=18):
        self.begin(pos,text,maxsize)
        self.fo = pygame.font.Font("data/SuperMarioBros.ttf",50)
        self.state = None
        self.makesurf()
    def begin(self,pos,text,maxsize=50):
        self.pos = pos
        self.size = 12
        self.text = text
        self.time = 0
        self.kill = 0
        self.maxsize = maxsize
    def makesurf(self):
        normaltext = self.fo.render(self.text,0,[255,255,255])
        aspect = float(normaltext.get_width())/float(normaltext.get_height())
        hi = self.size
        wi = int(aspect*float(hi))-10
        if wi>screen.get_width():
            wi = screen.get_width()
        hi = int((1/aspect)*float(wi))
        scaledtext = pygame.transform.scale(normaltext,[wi,hi])
        self.surf = scaledtext
    def update(self,dt):
        done = 0
        if self.size<self.maxsize:
            self.size += 1
            done +=1
        if self.pos[0]<20:
            self.pos[0]+=1
            done+=1
        if self.pos[1]<200:
            self.pos[1]+=10
            done+=1
        if done==0:
            self.time += 1*dt
            if self.time > 3:
                if self.pos[1]<screen.get_height():
                    self.pos[1]+=10
                else:
                    self.kill = 1
        self.makesurf()
        if self.kill:
            if self.state == "die":
                return "die"
            if self.state == "win":
                return "win"

darklayer = screen.convert()
darklayer.set_alpha(230)
darklayer.set_colorkey([255,0,255])
dirtyrects = [[0,0,screen.get_width(),screen.get_height()]]

clock = pygame.time.Clock()

class blah:
    def __init__(self):
        self.quit = 0
        self.back = pygame.image.load("data/grass.png")
        self.manage()
    def manage(self):
        keys = pygame.key.get_pressed()
        scr = pygame.image.load("data/startscreen.png")
        while not keys[l.K_SPACE]:
            screen.blit(scr,[0,0])
            pygame.display.flip()
            pygame.event.pump()
            keys = pygame.key.get_pressed()
        
        level = 0
        while not self.quit:
            
            if self.setuplevel(level)=="done":
                print "No more levels, you beat the WHOLE game!"
                break
            ret = self.loop()
            if ret =="done":
                print "Aw, you quit :("
                return
            if ret == "die":
                print "doh, you have to try again!"
                continue
            level += 1
        pygame.event.pump()
        keys = pygame.key.get_pressed()
        scr = pygame.image.load("data/winscreen.png")
        while not keys[l.K_SPACE]:
            screen.blit(scr,[0,0])
            pygame.display.flip()
            pygame.event.pump()
            keys = pygame.key.get_pressed()
        print "game beat"
    def randomtree(self,avoid=None):
        t = tree([0,0])
        col = 10
        tries = 0
        while col>-1 and tries<30:
            tries += 1
            t.pos[0] = random.randint(0,screen.get_width())
            t.pos[1] = random.randint(0,screen.get_height())
            col = t.rect.collidelist(self.trees)
            if col==-1:
                col = t.rect.collidelist(self.lis)
            if col==-1:
                col = t.rect.collidelist([self.man])
        return t
    def randomtrees(self,num):
        for i in range(num):
            self.trees.append(self.randomtree())
    def setuplevel(self,lvl):
        self.counters = {"treescut":0,"treesdeposited":0,"maxradius":0,"minradius":1000,"secondsplayed":0,"firedeaths":0}
        self.man = man([200,300],10)
        self.torchsize = 30
        self.torch = fire([40,40],self.torchsize)
        self.man.torch = self.torch
        self.lis = [self.torch]
        self.mons = []
        self.trees = []
        self.bile = []
        goal = ""
        self.losestate = "False"
        if lvl == 0:
            self.lis.extend([fire([screen.get_width()/2,screen.get_height()/2],100)])
            self.randomtrees(1)
            self.winstate = "treescut>=1"
            darklayer.set_alpha(0)
            goal = "Walk to the tree and hit space to chop it down"
        elif lvl == 1:
            self.man.pos[0] = 300
            self.man.pos[1] = 60
            self.lis.extend([fire([300,20],20)])
            self.trees.append(tree([250,200]))
            self.winstate = "treesdeposited>=1"
            darklayer.set_alpha(30)
            goal = "Chop a tree down and take it back to the fire!"
            self.losestate = "firedeaths>=1"
        elif lvl == 2:
            darklayer.set_alpha(60)
            goal = "don't let any fires die for 30 seconds!!!"
            self.lis.extend([fire([screen.get_width()/2-60,screen.get_height()/2],30),fire([screen.get_width()/2+60,screen.get_height()/2],30)])
            self.losestate = "firedeaths>=1"
            self.winstate = "secondsplayed>=30"
            self.randomtrees(10)
        elif lvl == 3:
            darklayer.set_alpha(100)
            goal = "hmm getting darker.  Cut down all trees!"
            self.lis.extend([fire([screen.get_width()/2,screen.get_height()/2],100)])
            self.randomtrees(12)
            self.winstate = "treescut>=12"
        elif lvl == 4:
            darklayer.set_alpha(130)
            goal = "Cut down 4 trees."
            self.lis.extend([fire([screen.get_width()/2,screen.get_height()/2],30)])
            self.randomtrees(6)
            self.winstate = "treescut>=4"
        elif lvl == 5:
            darklayer.set_alpha(200)
            goal = "Bring back 5 trees, but you can only carry 1 wood at a time!"
            self.lis.extend([fire([screen.get_width()/2,screen.get_height()/2],50)])
            self.randomtrees(7)
            self.man.carrylimit = 1
            self.winstate = "treesdeposited>=5"
        elif lvl == 6:
            darklayer.set_alpha(220)
            goal = "Bring back 8 trees, you can carry 2"
            self.lis.extend([fire([screen.get_width()/2,screen.get_height()/2],35)])
            self.randomtrees(10)
            self.man.carrylimit = 2
            self.winstate = "treesdeposited>=8"
        elif lvl == 7:
            darklayer.set_alpha(240)
            goal = "Bring back 8 trees in less than 60 seconds, carry 2"
            self.lis.extend([fire([screen.get_width()/2,screen.get_height()/2],80)])
            self.randomtrees(12)
            self.man.carrylimit = 2
            self.winstate = "treesdeposited>=8"
            self.losestate = "secondsplayed>=60"
        elif lvl == 8:
            darklayer.set_alpha(255)
            goal = "Keep fires burning for 60 seconds!"
            self.lis.extend([fire([20,20],80),fire([460,20],80),fire([20,460],80),fire([460,460],80)])
            self.randomtrees(12)
            self.winstate = "secondsplayed>=60"
            self.losestate = "firedeaths>=1"
        else:
            return "done"
        if "secondsplayed" in self.winstate and not goal:
            goal = "Survive for "+self.winstate[self.winstate.find("=",-1)-1:]+" seconds!"
        self.showgoal = 1
        self.goaltext = goaltext([0,20],goal)
        self.lasttime = clock.get_time()
        self.showgoal = 1
    def calcwin(self):
        winstate = self.winstate.replace("treescut","self.counters['treescut']").replace("treesdeposited","self.counters['treesdeposited']").replace("secondsplayed","self.counters['secondsplayed']").replace("maxradius","self.counters['maxradius']").replace("minradius","self.counters['minradius']").replace("firedeaths","self.counters['firedeaths']")
        if eval(winstate):
            return True

    def calclose(self):
        losestate = self.losestate.replace("treescut","self.counters['treescut']").replace("treesdeposited","self.counters['treesdeposited']").replace("secondsplayed","self.counters['secondsplayed']").replace("maxradius","self.counters['maxradius']").replace("minradius","self.counters['minradius']").replace("firedeaths","self.counters['firedeaths']")
        if eval(losestate):
            return True
        
    def update(self,rectlist,dt):
        
        #sort dirty rects
        #~ rectlist2 = []
        #~ ignore = []
        #~ for rec in rectlist:
            #~ #print rec
            #~ if rec in ignore:
                #~ continue
            #~ ignore.append(rec)
            #~ collisionlist = [rectlist[i] for i in pygame.Rect(rec).collidelistall(rectlist)]
            #~ ignore.extend(collisionlist[:])
            #~ if collisionlist:
                #~ rectlist2.append(pygame.Rect(rec).unionall(collisionlist))
            #~ else:
                #~ rectlist2.append(rec)
        #~ while rectlist:
            #~ del rectlist[0]
        #~ rectlist.extend(rectlist2)
        darklayer.fill([0,0,0])
        
        #lights
        for li in self.lis:
            li.blit(darklayer)
            
        #background
        for rec in rectlist:
            screen.blit(self.back,[rec[0],rec[1]],rec)
            
        #trees
        for t in self.trees:
            if t.rect.collidelist(rectlist)>-1:
                t.blit(screen,rec)
                
        #monsters
        for mon in self.mons:
            mon.blit(screen)
            
        #bile (monster spit)
        for bi in self.bile:
            bi.blit(screen)
            
        #man
        self.man.blit(screen)
        
        #fires
        for li in self.lis:
            li.blitcolors(screen)
            
        #shading
        for rec in rectlist[:]:
            screen.blit(darklayer,[rec[0],rec[1]],rec)
            rectlist.remove(rec)
            
        #text
        woodtext = fo.render("Wood:"+str(self.man.wood),0,[255,255,255])
        screen.blit(woodtext,[0,0])
        rectlist.append([0,0,0+woodtext.get_width(),0+woodtext.get_height()])
        fpstext = fo.render("Fps:"+str(int(self.fps)),0,[255,255,255])
        screen.blit(fpstext,[0,18])
        rectlist.append([0,18,0+fpstext.get_width(),18+fpstext.get_height()])
        treescuttext = fo.render("Trees cut:"+str(self.counters["treescut"]),0,[255,255,255])
        screen.blit(treescuttext,[0,36])
        rectlist.append([0,63,0+treescuttext.get_width(),36+treescuttext.get_height()])
        secondsplayedtext = fo.render("Secondsplayed:"+str(int(self.counters["secondsplayed"])),0,[255,255,255])
        screen.blit(secondsplayedtext,[0,54])
        rectlist.append([0,54,0+secondsplayedtext.get_width(),54+secondsplayedtext.get_height()])
        
        if self.showgoal and not self.goaltext.kill:
            screen.blit(self.goaltext.surf,self.goaltext.pos)
            response = self.goaltext.update(dt)
            if response == "die":
                return "die"
            elif response == "win":
                return "win"
            dirtyrects.append([self.goaltext.pos[0]-5,self.goaltext.pos[1]-10,self.goaltext.surf.get_width()+10,self.goaltext.surf.get_height()+20])
        #screen.blit(darklayer,[0,0])
    
    def loop(self):
        keys = pygame.key.get_pressed()
        while not keys[l.K_ESCAPE]:
            
            clock.tick(60)
            self.fps = clock.get_fps()
            
            dt = 0
            if self.fps:
                dt = (1.0/self.fps)
            
            self.counters["secondsplayed"]+=dt
            
            pygame.event.pump()
            keys = pygame.key.get_pressed()
            for li in self.lis:
                li.update(dt)
                if li.radi<=0:
                    if li.monitor:
                        self.counters["firedeaths"]+=1
                    self.lis.remove(li)
                if li.monitor:
                    if li.radi<self.counters["minradius"]:
                        self.counters["minradius"] = li.radi
                    if li.radi>self.counters["maxradius"]:
                        self.counters["maxradius"] = li.radi
            for tr in self.trees:
                tr.update(dt)
            for mon in self.mons:
                mon.update(dt)
            for bi in self.bile:
                bi.update(dt)
            self.man.update(dt)
            pygame.display.flip()
            if keys[l.K_RIGHT]:
                self.man.dir -= 100.0*dt
            if keys[l.K_LEFT]:
                self.man.dir += 100.0*dt
            if keys[l.K_UP]:
                self.man.moveforward(3,self.trees)
            #~ if keys[l.K_r]:
                #~ if self.man.torch:
                    #~ self.lis.append(fire(self.man.pos[:],50))
                    #~ self.lis.remove(self.man.torch)
                    #~ self.man.torch = None
            if keys[l.K_SPACE] and (not self.man.carrylimit or self.man.wood<self.man.carrylimit):
                self.man.image = manchop
                forwardpoint = self.man.pointforward(3)
                rec = pygame.Rect([forwardpoint[0]-1,forwardpoint[1]-1,3,3])
                trees = rec.collidelistall(self.trees)
                for t in trees:
                    tree = self.trees[t]
                    if tree.state == "tree":
                        tree.state = "stump"
                        self.man.wood += 1
                        self.counters["treescut"]+=1
            else:
                self.man.image = mansurf
            lights = self.man.rect.collidelistall(self.lis)
            if self.torch in self.lis and self.lis.index(self.torch) in lights:
                lights.remove(self.lis.index(self.torch))
            if lights:
                li = self.lis[lights[0]]
                if self.man.wood>0:
                    self.man.wood -= 1
                    li.radi += 20
                    self.counters["treesdeposited"]+=1
                if li.radi>=5:
                    if self.torch.radi<self.torchsize:
                        self.torch.radi = self.torchsize
            #~ if self.bile:
                #~ hitbile = self.man.rect.collidelistall(self.bile)
                #~ if hitbile:
                    #~ self.goaltext.begin([0,0],"The darkness closes in!!!")
                    #~ self.goaltext.losing = 1
                    
            if not self.lis and not self.goaltext.state:
                self.goaltext.begin([0,0],"The darkness closes in!!!")
                print "lose"
                self.goaltext.state = "die"
            
            #response = self.update(dirtyrects,dt)
            response = self.update([[0,0,screen.get_width(),screen.get_height()]],dt)
            
            if response == "die" or response == "win":
                return response
                
            if self.calclose() and not self.goaltext.state:
                self.goaltext.begin([0,0],"The darkness closes in!!!")
                print "lose"
                self.goaltext.state = "die"
            
            if self.calcwin() and not self.goaltext.state:
                self.goaltext.begin([0,0],"You win this level!")
                self.goaltext.state = "win"
                print "you win!"
        return "done"

g = blah()